package com.myntra.galera.test;

import java.io.IOException;
import java.util.ArrayList;
import java.util.List;
import java.util.concurrent.Callable;
import java.util.concurrent.ExecutionException;
import java.util.concurrent.ExecutorService;
import java.util.concurrent.Executors;
import java.util.concurrent.Future;
import java.util.concurrent.TimeUnit;

public class LoadRunner {

	public void bombard(int numOfJobs, int numOfThreds, int opsPerJob) throws InterruptedException, ExecutionException, IOException{
		
		System.out.println("===================================");
		System.out.println("============STARTING===============");
		
		ExecutorService executorService = Executors.newFixedThreadPool(numOfThreds);
		
		List<Callable<Object>> listCallable = new ArrayList<Callable<Object>>();
		for(int i = 0; i < numOfJobs; i ++){
			listCallable.add(Executors.callable(new Workload(opsPerJob)));
		}
		
		long startTime = System.currentTimeMillis();
		List<Future<Object>> futures = executorService.invokeAll(listCallable);	
		
		for(Future<Object> future : futures){
			future.get();
		}
		
		
		long endTime = System.currentTimeMillis();
		System.out.println("timeTaken is : " + (endTime - startTime) );
		executorService.shutdownNow();
		System.out.println("============FINISHING==============");
		System.out.println("===================================");
	}
	
	public static void main(String[] args) throws InterruptedException, ExecutionException, IOException {
		if(args.length >= 3){
			int numOfJobs = Integer.parseInt(args[0]);
			int numOfThreds = Integer.parseInt(args[1]);
			int opsPerJob = Integer.parseInt(args[2]);
			LoadRunner loadRunner = new LoadRunner();
			loadRunner.bombard(numOfJobs, numOfThreds, opsPerJob);
		}
	}
}
